/*****************************************************************************

GRAOUMF TRACKER 2

Copyright (c) 1996 - 2002 Laurent de Soras

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Contact the author : laurent@ohmforce.com
More information about this license : http://www.gnu.org/licenses/gpl.html

*****************************************************************************/



#if defined (MPAN_CURRENT_HEADER)
	#error Inclusion recursive du header MPAN.
#endif
#define	MPAN_CURRENT_HEADER

#if ! defined (MPAN_HEADER_INCLUDED)
#define	MPAN_HEADER_INCLUDED



/*\\\ INCLUDES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



/*\\\ CONSTANTES PUBLIQUES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



/*\\\ TYPES & STRUCTURES PUBLIQUES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



/*\\\ PROTOTYPES DES FONCTIONS PUBLIQUES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

/*--------------------------------------------------------------------------*/
/*      Gestions du panneau principal                                       */
/*--------------------------------------------------------------------------*/

bool	MPAN_manage_all (void);
void	MPAN_manage_main_icons (signed int sel_object, signed int sel_aine);
void	MPAN_manage_variables (int sel_object, int sel_aine);

void	MPAN_set_song_position (int type, signed int value);
signed int	MPAN_set_instrument_number (int type, signed int value, int object);
signed int	MPAN_set_sample_number (int type, signed int value, int object);
void	MPAN_set_line_step (int type, signed int value);
void	MPAN_set_song_speed (int type, signed int value);
void	MPAN_set_song_tempo (int type, double value);

/*--------------------------------------------------------------------------*/
/*      Affichages                                                          */
/*--------------------------------------------------------------------------*/

void	MPAN_display_main_pannel (void);
void	MPAN_display_status (bool disp_flag);
void	MPAN_display_cpu_time (bool disp_flag);
void	MPAN_display_clipping_level (bool disp_flag);
signed int	MPAN_display_message (const char *message_0);
void	MPAN_display_var_icons (bool disp_flag, bool force_flag);
void	MPAN_display_play_status (void);
void	MPAN_display_divers (void);
void	MPAN_refresh_display (void);
void	MPAN_refresh_dynamic_display (void);



/*\\\ VARIABLES EXTERNES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



/*\\\ FIN DU FICHIER \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

#endif

#undef MPAN_CURRENT_HEADER
